/*
  XVarStar, GCVS catalogue explorer
  Copyright (C) 2001-2008 Ivan Vitjuk 

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <string.h>

struct Constell{
        int id;
        char *name, *shrt;
};

static struct Constell constell[] = {
        {1, "Andromeda", "And"},
        {2, "Antila", "Ant"},
        {3, "Apus", "Aps"},
        {4, "Aquarius", "Aqr"},
        {5, "Aquila", "Aql"},
        {6, "Ara", "Ara"},
        {7, "Aries", "Ari"},
        {8, "Auriga", "Aur"},
        {9, "Bootes", "Boo"},
        {10, "Caelum", "Cae"},
        {11, "Camelopardalis", "Cam"},
        {12, "Cancer", "Cnc"},
        {13, "Canes Venatici", "CVn"},
        {14, "Canis Major", "CMa"},
        {15, "Canis Minor", "CMi"},
        {16, "Capricornus", "Cap"},
        {17, "Carina", "Car"},
        {18, "Cassiopeia", "Cas"},
        {19, "Centaurus", "Cen"},
        {20, "Cepheus", "Cep"},
        {21, "Cetus", "Cet"},
        {22, "Chameleon", "Cha"},
        {23, "Circinus", "Cir"},
        {24, "Columba", "Col"},
        {25, "Coma Berenices", "Com"},
        {26, "Corona Australis", "CrA"},
        {27, "Corona Borealis", "CrB"},
        {28, "Corvus", "Crv"},
        {29, "Crater", "Crt"},
        {30, "Crux", "Cru"},
        {31, "Cygnus", "Cyg"},
        {32, "Delphinus", "Del"},
        {33, "Dorado", "Dor"},
        {34, "Draco", "Dra"},
        {35, "Equuleus", "Equ"},
        {36, "Eridanus", "Eri"},
        {37, "Fornax", "For"},
        {38, "Gemini", "Gem"},
        {39, "Grus", "Gru"},
        {40, "Hercules", "Her"},
        {41, "Horologium", "Hor"},
        {42, "Hydra", "Hya"},
        {43, "Hydrus", "Hyi"},
        {44, "Indus", "Ind"},
        {45, "Lacerta", "Lac"},
        {46, "Leo", "Leo"},
        {47, "Leo Minor", "LMi"},
        {48, "Lepus", "Lep"},
        {49, "Libra", "Lib"},
        {50, "Lupus", "Lup"},
        {51, "Lynx", "Lyn"},
        {52, "Lyra", "Lyr"},
        {53, "Mensa", "Men"},
        {54, "Microscopium", "Mic"},
        {55, "Monoceros", "Mon"},
        {56, "Musca", "Mus"},
        {57, "Norma", "Nor"},
        {58, "Octans", "Oct"},
        {59, "Ophiuchus", "Oph"},
        {60, "Orion", "Ori"},
        {61, "Pavo", "Pav"},
        {62, "Pegasus", "Peg"},
        {63, "Perseus", "Per"},
        {64, "Phoenix", "Phe"},
        {65, "Pictor", "Pic"},
        {66, "Pisces", "Psc"},
        {67, "Piscis Austrinus", "PsA"},
        {68, "Puppis", "Pup"},
        {69, "Pyxis", "Pyx"},
        {70, "Reticulum", "Ret"},
        {71, "Sagitta", "Sge"},
        {72, "Sagittarius", "Sgr"},
        {73, "Scorpius", "Sco"},
        {74, "Sculptor", "Scl"},
        {75, "Scutum", "Sct"},
        {76, "Serpens", "Ser"},
        {77, "Sextans", "Sex"},
        {78, "Taurus", "Tau"},
        {79, "Telescopium", "Tel"},
        {80, "Triangulum", "Tri"},
        {81, "Triangulum Australe", "TrA"},
        {82, "Tucana", "Tuc"},
        {83, "Ursa Major", "UMa"},
        {84, "Ursa Minor", "UMi"},
        {85, "Vela", "Vel"},
        {86, "Virgo", "Vir"},
        {87, "Volans", "Vol"},
        {88, "Vulpecula", "Vul"},
        {0, NULL, NULL}
};

int const_get_id_by_name(const char *name)
{
        struct Constell *tmp;
 
        for(tmp = constell; tmp->id; tmp++)
                if(strcasecmp(name, tmp->name) == 0)
                        return tmp->id;
        return 0;
}

int const_get_id_by_shrt(const char *shrt)
{
        struct Constell *tmp;
        
        for(tmp = constell; tmp->id; tmp++)
                if(strcasecmp(shrt, tmp->shrt) == 0)
                        return tmp->id;
        return 0;
}

char *const_get_name_by_id(int id)
{
        struct Constell *tmp;
        
        for(tmp = constell; tmp->id; tmp++)
                if(tmp->id == id)
                        return tmp->name;
        return NULL;
}

char *const_get_name_by_shrt(const char *shrt)
{
        struct Constell *tmp;
        
        for(tmp = constell; tmp->id; tmp++)
                if(strcasecmp(shrt, tmp->shrt) == 0)
                        return tmp->name;
        return NULL;
}

char *const_get_shrt_by_id(int id)
{
        struct Constell *tmp;
        
        for(tmp = constell; tmp->id; tmp++)
                if(tmp->id == id)
                        return tmp->shrt;
        return NULL;
}

char *const_get_shrt_by_name(const char *name)
{
        struct Constell *tmp;
        
        for(tmp = constell; tmp->id; tmp++)
                if(strcasecmp(name, tmp->name) == 0)
                        return tmp->shrt;
        return NULL;
}
